#ifndef TAP_TRADE_API_H
#define TAP_TRADE_API_H

#include "TapTradeAPIDataType.h"
//#include "TapProtocol.h"

#if defined WIN32 || defined _WIN64
#define TAP_CDECL __cdecl
#define TAP_DLLEXPORT __declspec(dllexport)
#else
#define TAP_CDECL
#define TAP_DLLEXPORT
#endif

//TapTradeAPI.h
//ļTapTradeAPIṩߵĶӿڡͻصӿڡ

//TapTradeAPI Ļص֪ͨӿڡ
class ITapTradeAPINotify
{
public:
	/**
	* @brief ӳɹص֪ͨ
	* @ingroup G_T_Login
	*/
	virtual void TAP_CDECL OnConnect() = 0;
	/**
	* @brief	ϵͳ¼̻ص
	* @details	˺ΪLogin()¼ĻصLogin()ɹ·ӣȻAPI͵¼֤Ϣ
	*			¼ڼݷ͵¼ĻϢݵ˻صС
	* @param[in] errorCode ش,0ʾɹ
	* @param[in] loginRspInfo ½ӦϢerrorCode!=0loginRspInfo=NULL
	* @attention	ûصسɹ˵û¼ɹǲAPI׼ϡ
	* @ingroup G_T_Login
	*/
	virtual void TAP_CDECL OnRspLogin(TAPIINT32 errorCode, const TapAPITradeLoginRspInfo *loginRspInfo) = 0;
	/**
	* @brief	֪ͨûAPI׼
	* @details	ֻûصյ˾֪ͨʱܽкĸݲѯ\n
	*			˻صAPIܷı־
	* @attention ſԽк
	* @ingroup G_T_Login
	*/
	virtual void TAP_CDECL OnAPIReady() = 0;
	/**
	* @brief	APIͷʧȥӵĻص
	* @details	APIʹù߱ʧȥӺ󶼻ᴥ˻ص֪ͨûѾϿ
	* @param[in] reasonCode Ͽԭ롣
	* @ingroup G_T_Disconnect
	*/
	virtual void TAP_CDECL OnDisconnect(TAPIINT32 reasonCode) = 0;
	/**
	* @brief ֪ͨû޸Ľ
	* @param[in] sessionID ޸ĻỰID,ChangePasswordصĻỰIDӦ
	* @param[in] errorCode ش룬0ʾɹ
	* @ingroup G_T_UserInfo
	*/
	virtual void TAP_CDECL OnRspChangePassword(TAPIUINT32 sessionID, TAPIINT32 errorCode) = 0;
	/**
	* @brief ûԤϢ
	* @param[in] sessionID ûԤϢĻỰID
	* @param[in] errorCode ش룬0ʾɹ
	* @param[in] info ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @note ýӿδʵ
	* @ingroup G_T_UserInfo
	*/
	virtual void TAP_CDECL OnRspSetReservedInfo(TAPIUINT32 sessionID, TAPIINT32 errorCode, const TAPISTR_50 info) = 0;
	/**
	* @brief	ûϢ
	* @details	˻صӿûزѯʽ˺ŵϸϢûбҪõ˺űűȻںĺʹá
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast ʾǷһݣ
	* @param[in] info ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_AccountInfo
	*/
	virtual void TAP_CDECL OnRspQryAccount(TAPIUINT32 sessionID, TAPIUINT32 errorCode, TAPIYNFLAG isLast, const TapAPIAccountInfo *info) = 0;
	/**
	* @brief ʽ˻ʽϢ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_AccountDetails
	*/
	virtual void TAP_CDECL OnRspQryFund(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIFundData *info) = 0;
	/**
	* @brief	ûʽ仯֪ͨ
	* @details	ûίгɽʽݵı仯Ҫûʵʱ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_AccountDetails
	*/
	virtual void TAP_CDECL OnRtnFund(const TapAPIFundData *info) = 0;
	/**
	* @brief ϵͳеĽϢ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void TAP_CDECL OnRspQryExchange(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIExchangeInfo *info) = 0;
	/**
	* @brief	ϵͳƷϢ
	* @details	˻صӿûصõƷϢ
	* @param[in] sessionID ĻỰIDGetAllCommodities()ضӦ
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_Commodity
	*/
	virtual void TAP_CDECL OnRspQryCommodity(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPICommodityInfo *info) = 0;
	/**
	* @brief ϵͳкԼϢ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_Contract
	*/
	virtual void TAP_CDECL OnRspQryContract(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPITradeContractInfo *info) = 0;
	/**
	* @brief	ԼϢ
	* @details	ûµĺԼҪڽʱзºԼʱûԼϢ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_Contract
	*/
	virtual void TAP_CDECL OnRtnContract(const TapAPITradeContractInfo *info) = 0;
	/**
	* @brief ίСµĻطµ͹ġ
	* @details	յͻµίݺͻᱣȴͬʱûһ
	*			ίϢ˵ȷû󣬷صϢаȫίϢ
	*			ͬʱһʾίеίкš
	* @param[in] info ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnOrder(const TapAPIOrderInfoNotice *info) = 0;
	/**
	* @brief	ضԱ
	* @details	µȲĽ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] info ľϢerrorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @note ýӿĿǰûõвͨOnRtnOrder
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRspOrderAction(TAPIUINT32 sessionID, TAPIUINT32 errorCode, const TapAPIOrderActionRsp *info) = 0;
	/**
	* @brief	زѯίϢ
	* @details	ûѯίеľϢ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast ʾǷһݣ
	* @param[in] info ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryOrder(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIOrderInfo *info) = 0;
	/**
	* @brief زѯίб仯Ϣ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 룬errorCode==0ʱinfoָ򷵻صίб仯̽ṹ壬ȻΪNULL
	* @param[in] isLast ʾǷһݣ
	* @param[in] info صίб仯ָ롣
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryOrderProcess(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIOrderInfo *info) = 0;
	/**
	* @brief زѯĳɽϢ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryFill(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIFillInfo *info) = 0;
	/**
	* @brief	ĳɽϢ
	* @details	ûίгɽûͳɽϢ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnFill(const TapAPIFillInfo *info) = 0;
	/**
	* @brief زѯĳֲ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryPosition(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIPositionInfo *info) = 0;
	/**
	* @brief ֱֲ仯֪ͨ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnPosition(const TapAPIPositionInfo *info) = 0;
	/**
	* @brief زѯƽ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryClose(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPICloseInfo *info) = 0;
	/**
	* @brief ƽݱ仯
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnClose(const TapAPICloseInfo *info) = 0;
	/**
	* @brief ֲӯ֪ͨ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @note עݣ趨LoginʱNoticeIgnoreFlagΡ
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnPositionProfit(const TapAPIPositionProfitNotice *info) = 0;
	/**
	* @brief ѯӦ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһݣ
	* @param[in] info	  ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_DeepQuote
	*/
	virtual void TAP_CDECL OnRspQryDeepQuote(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIDeepQuoteQryRsp *info) = 0;
	/**
	* @brief ʱ״̬ϢѯӦ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention  Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void TAP_CDECL OnRspQryExchangeStateInfo(TAPIUINT32 sessionID,TAPIINT32 errorCode, TAPIYNFLAG isLast,const TapAPIExchangeStateInfo * info)=0;
	/**
	* @brief ʱ״̬Ϣ֪ͨ	
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention  Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeSystem
	*/
	virtual void TAP_CDECL OnRtnExchangeStateInfo(const TapAPIExchangeStateInfoNotice * info)=0;
	/**
	* @brief ѯ֪ͨ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeActions
	*/
	virtual void TAP_CDECL OnRtnReqQuoteNotice(const TapAPIReqQuoteNotice *info) = 0;

	/**
	* @brief ϢѯӦ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention  Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_UpperChannelInfo
	*/
	virtual void TAP_CDECL OnRspUpperChannelInfo(TAPIUINT32 sessionID,TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIUpperChannelInfo * info)=0;
        /**
	* @brief ͻշӦ
        * @details   ֤㷽ʽ*ÿֳ**۸\n
        *             ֤𶨶㷽ʽ*\n
        *             ѾԷʽ㷽ʽ*+*ÿֳ*۸*
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention  Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_AccountRentInfo
	*/
	virtual void TAP_CDECL OnRspAccountRentInfo(TAPIUINT32 sessionID,TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIAccountRentInfo * info)=0;
	/**
	* @brief ûύû¼ϢӦ(ֱмûյӦ)
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention  Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_UserInfo
	*/
	virtual void TAP_CDECL OnRspSubmitUserLoginInfo(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPISubmitUserLoginRspInfo * info) = 0;
    /**
	* @brief ѯû˵Ӧ
    * @details	ѯtxtļʽʱصд뵽صtxtļв鿴ѯpdfļʱҪصת浽pdfļУpdfĶߴ򿪡
    *           дļҪöƵķʽд롣ļϴݻְصisLastΪAPIYNFLAG_YESʱļϡ
	* @param[in] sessionID ĻỰID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] info		ָ򷵻صϢṹ塣errorCodeΪ0ʱinfoΪա
	* @attention Ҫ޸ĺɾinfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
	*/
	virtual void TAP_CDECL OnRspQryBill(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIBillQryRsp *info) = 0;
    /**
    * @brief ͻֻѯӦ
	* @param[in] sessionID ID
	* @param[in] errorCode 롣0 ʾɹ
	* @param[in] isLast 	ʾǷһ
	* @param[out] info	ָ򷵻صϢṹ塣
	* @attention  Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
    */
    virtual void TAP_CDECL OnRspQryAccountStorage(TAPIUINT32 sessionID, TAPIINT32 errorCode, TAPIYNFLAG isLast, const TapAPIAccountStorageInfo* info) = 0;
    /**
    * @brief ͻֻ֪ͨ
	* @param[out] pInfo	ָ򷵻صϢṹ塣
	* @attention  Ҫ޸ĺɾpRspInfoָʾݣýЧ
	* @ingroup G_T_TradeInfo
    */
    virtual void TAP_CDECL OnRtnAccountStorage(const TapAPIAccountStorageInfo* info) = 0;
};

//TapTradeAPI ⹦ܽӿڡûԵõĹܺ
class ITapTradeAPI
{
public:
	/**
	* @brief	APIĻصӿڶ
	* @details	ϵͳAPI֪ͨͨõĻص֪ͨʹߡ
	*			ITapTradeAPINotifyAPIĻصӿڣûҪ̳ʵִ˽ӿûҪĹܡ
	*			ûûûصӿڣAPIûκõϢ\n
	*			ITapTradeAPINotifyϸ鿴TapTradeAPI.h ļ
	* @param[in] apiNotify ʵITapTradeAPINotifyӿڵĶָ롣
	* @operationtype ͬ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 TAP_CDECL SetAPINotify(ITapTradeAPINotify *apiNotify) = 0;
	/**
	* @brief ÷IPַͶ˿ڡ
	* @param[in] IP   IPַ
	* @param[in] port ˿ں
	* @operationtype ͬ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 TAP_CDECL SetHostAddress(const TAPICHAR *IP, TAPIUINT16 port) = 0;
	/**
	* @brief	¼APIӷ񣬽·¼֤
	* @details	ʹúǰûҪɷSetHostAddress()ҴTapAPITradeLoginAuth͵ûϢ
	*			Ҫúûصӿڡ\n
	*			¼нӵķϢͨصOnConnectظû\n
	*			ӽû֤ϢͨصOnLogin()ظû\n
	*			¼ɹAPIԶAPIĳʼAPIݣѯԺͨصOnAPIReady()
	*			ָʾûAPIʼɣԽкĲˡ
	* @param[in] loginAuth ¼֤Ϣṹָ롣¼Ҫ֤Ϣ
	* @retval 0 ¼ɹAPIʼ׼̨
	* @retval 0 
	* @operationtype 첽
	* @note TapAPITradeLoginAuthеNoticeIgnoreFlagڱǷض֪ͨص\n
	*       磺ҪOnRtnFundOnRtnPositionProfit,ô趨\n 
	*       NoticeIgnoreFlag = TAPI_NOTICE_IGNORE_FUND | TAPI_NOTICE_IGNORE_POSITIONPROFIT;
	* @attention Login()óɹֻǴڷ·ӣֻлصOnLogin()ķָʾûǷɹ¼ˡ
	* @ingroup G_T_Login
	*/
	virtual TAPIINT32 TAP_CDECL Login(const TapAPITradeLoginAuth *loginAuth) = 0;
	/**
	* @brief	Ͽͷ·ӡ
	* @details	úAPIǳϿӡ
	* @operationtype ͬ
	* @ingroup G_T_Disconnect
	*/
	virtual TAPIINT32 TAP_CDECL Disconnect() = 0;
	/**
	* @brief	޸롣
	* @details	ɹû뽫ónewPassword
	* @param[out]	sessionID ش˴޸ĻỰID;
	* @param[in]	req ޸Ľṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 TAP_CDECL ChangePassword(TAPIUINT32 *sessionID, const TapAPIChangePasswordReq *req) = 0;
	/**
	* @brief	жϵ¼ûǷĳȨޡ
	* @details	ûȨû¼ʱѾݸAPIԴ˺ִеǱصĲѯ
	* @param[in] rightID ȨID
	* @retval 0 Ȩ
	* @retval 0 Ȩ
	* @operationtype ͬ
	* @ingroup G_T_UserRight
	*/
	virtual TAPIINT32 TAP_CDECL HaveCertainRight(TAPIRightIDType rightID) = 0;
	/**
	* @brief	ûԤϢ
	* @details	ûһΪ50ڵַϢ´ε¼ԵõϢ
	*			ҪûȷԼ˺ţҪзα
	* @param[out]	sessionID ĻỰID;
	* @param[in] info	ԤϢַָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @note ýӿδʵ
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 TAP_CDECL SetReservedInfo(TAPIUINT32 *sessionID, const TAPISTR_50 info) = 0;
	/**
	* @brief ѯûʽ˺
	* @details	TapAPIAccQryReqǰʽ˺ŽṹĽṹ壬ûҪʵ˽ṹ壬
	*			ǲҪдṹҪûʽ˺ţʽ˺
	*			ںĺкܶຯҪʹõ
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq ѯûʽ˺ŵĽṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_AccountInfo
	*/
	virtual TAPIINT32 TAP_CDECL QryAccount(TAPIUINT32 *sessionID, const TapAPIAccQryReq *qryReq) = 0;
	/**
	* @brief	ѯͻʽ
	* @details	TapAPIFundReqҪQryAccount()ȡʽ˺š
	*			Ļصʽ˺ŵʽϢ\n
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq	ѯͻʽĽṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_AccountDetails
	* @attention ÿε½ýӿֻܽһεáʼʱһΣ֪ͨͨOnRtnFundȡá
	*/
	virtual TAPIINT32 TAP_CDECL QryFund(TAPIUINT32 *sessionID, const TapAPIFundReq *qryReq) = 0;
	/**
	* @brief ѯϵͳϢ
	* @param[out] sessionID ĻỰID;
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeSystem
	*/
	virtual TAPIINT32 TAP_CDECL QryExchange(TAPIUINT32 *sessionID) = 0;
	/**
	* @brief	ѯϵͳƷϢ
	* @details	ȡеƷϢ
	* @param[out] sessionID ĻỰID;
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_Commodity
	*/
	virtual TAPIINT32 TAP_CDECL QryCommodity(TAPIUINT32 *sessionID) = 0;
	/**
	* @brief	ѯϵͳָƷֵĺԼϢ
	* @details	ʹô˺ǰҪQrycommodityInfo()ȡƷϢ
	*			ȻѡҪƷֽϢTapAPICommodityṹɲѯ
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq ѯϵͳָƷֵĺԼϢĽṹָ;\n
	*				    òֶΪѡֶΣ·ѯ\n
	*					1.ȫգкԼ\n
	*					2.ЧýƷֵĺԼ\n
	*					3.ƷЧýָƷ͵ĺԼ\n
	*					4.롢ƷͺƷֱ붼ЧƷµкԼ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_Contract
	*/
	virtual TAPIINT32 TAP_CDECL QryContract(TAPIUINT32 *sessionID, const TapAPICommodity *qryReq) = 0;
	/**
	* @brief	µ
	* @details	ûµĲ
	*			ûµûʽ𡢳ֲ֡ƽ֡ʽ𡢷رǵȶݵı仯ûµĵɽ
	*			жص֪ͨûչʾݵı仯
	* @param[out]	sessionID ĻỰID;
	* @param[in]	order µί
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 TAP_CDECL InsertOrder(TAPIUINT32 *sessionID, const TapAPINewOrder *order) = 0;
	/**
	* @brief	
	* @details	ûίûȫɽ֮ǰʣίС
	* @param[out]	sessionID ĻỰID;
	* @param[in]	order ί
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 TAP_CDECL CancelOrder(TAPIUINT32 *sessionID, const TapAPIOrderCancelReq *order) = 0;
	/**
	* @brief	ѯίϢ
	* @details	صǰίϢԲѯίУҲԲѯδίС\n
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	* @attention ýӿڿԶεãвѯƵʵҪÿԲѯһ
	*/
	virtual TAPIINT32 TAP_CDECL QryOrder(TAPIUINT32 *sessionID, const TapAPIOrderQryReq *qryReq) = 0;
	/**
	* @brief	ѯίб仯
	* @details	ѯûίеı仯̣ѯίеÿһεı仯
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq ί̲ѯϢṹָ롣
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 TAP_CDECL QryOrderProcess(TAPIUINT32 *sessionID, const TapAPIOrderProcessQryReq *qryReq) = 0;
	/**
	* @brief ѯɽϢ
	* @details	ѯϵͳгɽϢ
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq ɽѯϢṹָ롣
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	* @attention ÿε½ýӿֻܽһεáʼʱһΣ֪ͨͨOnRtnFillȡá
	*/
	virtual TAPIINT32 TAP_CDECL QryFill(TAPIUINT32 *sessionID, const TapAPIFillQryReq *qryReq) = 0;
	/**
	* @brief	ѯûֲ
	* @details	ѯûгֲϢ
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq	ѯûֲĽṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	* @attention ýӿڿԶεãвѯƵʵҪÿԲѯһ
	*/
	virtual TAPIINT32 TAP_CDECL QryPosition(TAPIUINT32 *sessionID, const TapAPIPositionQryReq *qryReq) = 0;
	/**
	* @brief ѯƽּ¼
	* @details	ѯûеƽּ¼
	* @param[out] sessionID ĻỰID;
	* @param[in] qryReq	ѯƽּ¼Ľṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	* @attention ÿε½ýӿֻܽһεáʼʱһΣ֪ͨͨOnRtnCloseȡá
	*/
	virtual TAPIINT32 TAP_CDECL QryClose(TAPIUINT32 *sessionID, const TapAPICloseQryReq *qryReq) = 0;
	/**
	* @brief ѯ
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq	ѯṹָ룬ڶԼա
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_DeepQuote
	*/
	virtual TAPIINT32 TAP_CDECL QryDeepQuote(TAPIUINT32 *sessionID, const TapAPIContract *qryReq) = 0;
	/**
	* @brief	ѯʱ״̬Ϣ
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq ѯʱ״̬Ϣṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeSystem
	*/
	virtual TAPIINT32 TAP_CDECL QryExchangeStateInfo(TAPIUINT32 * sessionID,const TapAPIExchangeStateInfoQryReq * qryReq)=0;
	/**
	* @brief   ѯϢ,Ҫڿͻµʱָͨţѡӽ뽻ǰû
	* @param[out]    sessionID ĻỰID;
	* @param[in]	 qryReq    ͨϢѯṹָ
	* @retval  0   ɹ
	* @retval  0 
	* @operationtype 첽
	* @ingroup G_T_UpperChannelInfo
	*/
	virtual TAPIINT32 TAP_CDECL QryUpperChannel(TAPIUINT32 * sessionID, const TapAPIUpperChannelQryReq * qryReq)=0;
        /**
	* @brief   ѯͻշ,ҪڿͻѯԼշʣڽ
	* @param[out]    sessionID ĻỰID;
	* @param[in]	 qryReq    ͻշʲѯṹָ
	* @retval  0   ɹ
	* @retval  0 
	* @operationtype 첽
	* @ingroup G_T_AccountRentInfo
	*/
	virtual TAPIINT32 TAP_CDECL QryAccountRent(TAPIUINT32 * sessionID, const TapAPIAccountRentQryReq * qryReq)=0;
	/**
	* @brief	
	* @details	ıίн¿ʼɽ
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq ί
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeActions
	*/
	virtual TAPIINT32 TAP_CDECL ActivateOrder(TAPIUINT32 *sessionID, const TapAPIOrderActivateReq *qryReq) = 0;
	/**
	* @brief		мûύû¼Ϣ
	* @details		¼ɹֻмûʹøú
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq û¼Ϣ
	* @retval		0 ɹ0 
	* @operationtype 첽
	* @ingroup G_T_UserInfo
	*/
	virtual TAPIINT32 TAP_CDECL SubmitUserLoginInfo(TAPIUINT32 *sessionID, const TapAPISubmitUserLoginInfo* qryReq) = 0;
    /**
	* @brief ѯû˵
	* @param[out]	sessionID ĻỰID;
	* @param[in]	qryReq	ѯʵĽṹָ
	* @retval 0 ɹ
	* @retval 0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	*/
	virtual TAPIINT32 TAP_CDECL QryBill(TAPIUINT32 *sessionID, const TapAPIBillQryReq *qryReq) = 0;
    /**
	* @brief ͻֻѯ
	* @param[in]	sessionID ID
	* @param[in]	pReqInfo ͻֻѯṹ
	* @retval		0 ɹ;0 
	* @operationtype 첽
	* @ingroup G_T_TradeInfo
	*/
    virtual TAPIINT32 TAP_CDECL QryAccountStorage(TAPIUINT32 *sessionID, const TapAPIAccountStorageQryReq *qryReq) = 0;
};

//-----------------------------TapTradeAPI------------------------------------


#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

/**
* @brief	TapTradeAPIĽӿڶ
* @details	APIĽӿ
* @param[in] appInfo ӦóϢKeyOperationLogPath ·Ϊʱ־
* @param[in] iResult ӿڵĴ롣
* @retval NULL	ʧܣԭͨiResultжϡ
* @retval !NULL	ʵITapTradeAPIӿڵĶָ롣
* @ingroup G_T_API
*/
TAP_DLLEXPORT ITapTradeAPI *TAP_CDECL CreateTapTradeAPI(const TapAPIApplicationInfo *appInfo, TAPIINT32 &iResult);
/**
* @brief	ͨCreateTapTradeAPIITapTradeAPI
* @param[in] apiObj ITapTradeAPIָ롣
* @ingroup G_T_API
*/
TAP_DLLEXPORT void TAP_CDECL FreeTapTradeAPI(ITapTradeAPI *apiObj);
/**
* @brief	ȡTapTradeAPIİ汾Ϣ
* @ingroup G_T_API
*/
TAP_DLLEXPORT const TAPICHAR *TAP_CDECL GetTapTradeAPIVersion();
/**
* @brief	APIĿ¼
* @details	úͬʱpathĿ¼´գʽTapTradeAPI[YYYYMMDD].log)ļ\n
*			ûдļ»ͼļ\n
*			ļбΪAPIյҪݺAPIʹúʹ־
* @param[in] path Ŀ¼ãĿ¼WindowΪ\\ߡ/, LinuxΪ/
* @retval 0 ɹ
* @retval 0 
* @operationtype ͬ
* @ingroup G_T_LogConfig
*/
TAP_DLLEXPORT TAPIINT32 TAP_CDECL SetTapTradeAPIDataPath(const TAPICHAR *path);
/**
* @brief	API־
* @details	趨־ֻеʵ־˴趨ļͬʱŻὫ־дSetTapTradeAPIDataPath()򿪵־ļ\n
* @param[in]	level ־\n
*					APILOGLEVEL_NONE	¼־\n
*					APILOGLEVEL_ERROR	¼Error־\n
*					APILOGLEVEL_WARNING	¼ErrorWarning־\n
*					APILOGLEVEL_DEBUG	¼ErrorWarningDebug־\n
* @retval 0 趨ɹ
* @retval 0 
* @operationtype ͬ
* @ingroup G_T_LogConfig
*/
TAP_DLLEXPORT TAPIINT32 TAP_CDECL SetTapTradeAPILogLevel(TAPILOGLEVEL level);

#ifdef __cplusplus
}
#endif // __cplusplus


#endif // TAP_TRADE_API_H