#include "TapTradeAPI.h"
#include "TapAPIError.h"
#include "Trade.h"
#include "TradeConfig.h"

#include <iostream>
#include <string.h>
using namespace std;

int main(int argc, char* argv[])
{
	//ȡAPIİ汾Ϣ
	cout << GetTapTradeAPIVersion() << endl;

	//APIʵ
	TAPIINT32 iResult = TAPIERROR_SUCCEED;
	TapAPIApplicationInfo stAppInfo;
	strcpy(stAppInfo.AuthCode, DEFAULT_AUTHCODE);
	strcpy(stAppInfo.KeyOperationLogPath, "");
	ITapTradeAPI *pAPI = CreateTapTradeAPI(&stAppInfo, iResult);
	if (NULL == pAPI){
		cout << "APIʵʧܣ룺" << iResult <<endl;
		return -1;
	}

	//趨ITapTradeAPINotifyʵ࣬첽ϢĽ
	Trade objTrade;
	pAPI->SetAPINotify(&objTrade);
	

	//ԣµ
	objTrade.SetAPI(pAPI);
	objTrade.RunTest();

    objTrade.AuthUdpServer();
    
    objTrade.InsertUdpOrder();

	return 0;
}